地址:http://acm.hdu.edu.cn/showproblem.php?pid=4283
You Are the One
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Problem Description
The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?
Input
The first line contains a single integer T, the number of test cases. For each case, the first line is n (0 < n <= 100)
The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)
The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)
Output
For each test case, output the least summary of unhappiness .
Sample Input
2 5 1 2 3 4 5 5 5 4 3 2 2
Sample Output
Case #1: 20 Case #2: 24
题意:有n个人参加电视节目,每个人都有一个愤怒值Di,若这个人是第k位上场的选手的话,他所产生的愤怒值是(k-1)*Di。在才赛通道旁边有个小黑屋可以作为栈来使队伍序列改变,问最小产生的愤怒值是多少。
思路:一开始认为是记忆化搜索,但是超时了。百度了下发现是区间DP,了解了下区间DP的定义然后自己编了下代码试试,立马就出错了,我在编写代码时区间内保存的是最优值,没有考虑对于别的情况是否适用,所以WA。
区间DP就是在区间内求得最优解,然后再组合在一起得出最优解。
对于该题来说,建立数组dp[i][j]表示从i号选手到j号选手上台所产生的最小愤怒值。
dp[i][j]中i可以第一个上台,也可以第j-i+1个上台,所以我们要遍历i的位置来求最小的愤怒值。
代码:
#include<iostream>
#include<queue>
#include<algorithm>
#include<cstdio>
#include<cstring>
using namespace std;
#define LL __int64
#define Mod 0xfffffff
int dp[110][110],num[110],sum[110]={0};
int main(){
int t,cas=1,n;
scanf("%d",&t);
while(t--){
scanf("%d",&n);
for(int i=1;i<=n;i++){
scanf("%d",&num[i]);
sum[i]=sum[i-1]+num[i];
}
for(int l=1;l<n;l++){ //先将长度为2的区间最优解全部求出,然后依次增加
for(int i=1;i<=n-l;i++){
int j=i+l;
dp[i][j]=Mod;
for(int k=1;k<=j-i+1;k++){ //表示i是第k个上台的
dp[i][j]=min(dp[i][j],num[i]*(k-1)+dp[i+1][i+k-1]+dp[i+k][j]+(sum[j]-sum[i+k-1])*k);
}
}
}
printf("Case #%d: %d\n",cas++,dp[1][n]);
}
return 0;
}